Subject: Re: DEC roots of PIP, DDT, etc. (& early OS/8)

From: [email-masked] (Eric Werme)
Date: 23 Aug 1994 15:21:03 -0400

Hear are two replies I received from people much closer to those early roots
than I.

------------------------------------------------------------

From: "John Green" <[email-masked]>

You don't have to appeal to CJL.
==========
I believe (CJL - help!) that the PDP-8 folks writing OS/8 (TS/8?)
picked up the names and general command syntax from their PDP-10
exposure.  Many of those people moved to RT-11 and copied all of
that.  A DDT for the -11 came from CMU in the mid 1970s, but I'm
not sure if that ever became a distributed piece of code either
through DEC or DECUS.
==========
    What do you mean PDP-8 folks writing OS/8? It was a one man project
conceived and implemented by my roommate Richard F Lary. He called it the First
Upward Compatible Keyboard Monitor (FUCK Monitor). There was an intention,
perhaps only humorous, to write a PDP-15 Second Upward Compatible Keyboard
Monitor (SUCK Monitor).
    He took the idea to his boss on Wednesday. His boss said to start work on
it as a background project and keep his regular work on schedule. If he ever
got within 6 months of finishing they would assign a tech writer to it and
consider releasing it.
    Richie took that as a challenge and demoed the system to his boss the
following Monday. It was complete enough to load a primitive PIP off DEC Tape
which would give a prompt and copy files. Of course it took another year of
work before Programming System/8 (PS/8) was released. At Eli Glaser's (a Long
Island NY salesman) suggestion the system was renamed OS/8 as Eli said he could
sell more machines with an Operating System than he could with a Programming
System.
    The intention of the project was to be able to have an ASR-33 in an empty
room and give a user a Turing Test to see if he could determine whether it was
connected to PS/8 or TOPS-10.
[werme nitpick: I'm not certain about 1971, but I know in 1969 (see below)
 "TOPS-10" wasn't shipping.  Ihe OS was called merely the "PDP-10 Monitor".]

Regards,
John C

------------------------------------------------------------

From: [email-masked] (A cowflop in the cybernetic meadow)

John's information is fairly accurate, a coupla nits:

- I wrote the first draft of the FUCK Monitor, which became the BLEEP Monitor,
which was released as PS/8 (Programming System/8, my term, because I didn't
think any system which didn't enable interrupts should be called an OS), which
became OS/8 during the Nixon Wage/Price Freeze in 1971 (because, um, if we
called it PS/8 Release 2 we couldn't charge a higher price for it). I didn't
write the released product alone, however, I had help from a guy named Ed
Friedman and another guy named Paul <memory loss>. 

- Digital had a program development system for the PDP-8 at the time (1969) but
it was bad, bad, bad. We acquired the rights to a system named CPS (Cooley
Programming System, developed at Cooley Lab at the University of Michigan)
in exchange for some hardware and I was given the job of productizing it. CPS
was miles better than what we had, but it had LOTS of internal restrictions and
its user interface was alien (modeled on TSS/360, which is what they had at
Michigan) so I decided to scrap it instead. My manager, Chuck Conley, covered
me by telling the rest of the company that we were just making some small
changes to CPS to make it more compatible.

- Actually, there wasn't a DDT on the PDP-8 for a long time; we couldn't afford
the room for the symbol table. We used ODT, Octal Debugging Technique, with
similiar syntax to DDT but no symbols. No big deal when a large program (like
our Fortran compiler) was less than 10KB...

							Richie